unit UdllMain;

interface

uses
  WinTypes, WinProcs, Messages;

const
 WM_HCBT_DESTROYWND = $0499;
 WM_HCBT_CREATEWND  = $0500;

procedure APM_Init(AOwnerHandle: THandle); export;
function APM_CBTProc(code: integer; wParam: word;
                   lParam: longint): longint; export;

implementation

var
 HookHandle: HHook;
 OwnerHandle: THandle;

procedure APM_Init(AOwnerHandle: THandle);
 begin
  OwnerHandle:=AOwnerHandle;
 end;

function APM_CBTProc(code: integer; wParam: word;
                   lParam: longint): longint;
 type pcbt_createwnd=^tcbt_createwnd;
 var lhInstance: longint;
 begin
  result:=0;
  if code=HCBT_DESTROYWND then
   result:=SendMessage(OwnerHandle,WM_HCBT_DESTROYWND,wParam,lParam)
  else
  if code=HCBT_CREATEWND then
   begin
    lhInstance:= pcbt_createwnd(lParam)^.lpcs^.hInstance;
    if pcbt_createwnd(lParam)^.lpcs^.hwndParent=0 then
     PostMessage(OwnerHandle,WM_HCBT_CREATEWND,wParam,lhInstance);
   end;
  if code<0 then CallNextHookEx(HookHandle,code,wParam,lParam);
 end;

end.
