unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ShellApi, ExtCtrls;

const
 WM_HCBT_DESTROYWND = $0499;
 WM_HCBT_CREATEWND  = $0500;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Panel1: TPanel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
   procedure MsgDestroyWndProc(var mess:TMessage);message WM_HCBT_DESTROYWND;
   procedure MsgCreateWndProc(var mess:TMessage);message WM_HCBT_CREATEWND;
  end;

procedure APM_Init(AHandle:THandle);far;
function APM_CBTProc(code:integer;wParam:word;lParam:longint):longint;far;

var
  Form1: TForm1;
  HookHandle: HHook;

implementation

{$R *.DFM}

function APM_CBTProc; external 'apmdll';
procedure APM_Init; external 'apmdll';

procedure TForm1.MsgCreateWndProc(var mess:TMessage);
 var i:integer;
 begin
  i:=0;
  while i<ListBox1.Items.Count do
   begin
    if mess.lparam=StrToInt(Copy(ListBox1.Items.Strings[i],1,5)) then
     ListBox1.Items.Strings[i]:=ListBox1.Items.Strings[i]+' hwnd: $'
                                 +IntToHex(mess.wParam,4);
    inc(i);
   end;
  mess.result:=0;
 end;

procedure TForm1.MsgDestroyWndProc(var mess:TMessage);
 var i: integer;
 begin
  i:=0;
  while i<ListBox1.Items.Count do
   begin
    if mess.wparam=StrToInt(Copy(ListBox1.Items.Strings[i],13,5)) then
     ListBox1.Items.Delete(i);
    inc(i);
   end;
  mess.result:=0;
 end;

procedure TForm1.FormCreate(Sender: TObject);
var Aproc: THookProc;
begin
 APM_Init(Handle);
 @AProc:=@APM_CBTProc;
 HookHandle:=SetWindowsHookEx(WH_CBT,AProc,hInstance,0);
 Caption:=IntToHex(hInstance,4);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 if HookHandle>0 then UnhookWindowsHookEx(HookHandle);
end;

procedure TForm1.Button1Click(Sender: TObject);
var lHandle: THandle;
begin
 lHandle:=ShellExecute(Handle, nil, 'notepad.exe', nil, nil, SW_SHOW);
 ListBox1.Items.Add('$'+IntToHex(lHandle,4));
end;

end.
